Coin: SoEngineOutput Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoEngineOutput Class Reference
Engine Classes

The SoEngineOutput class is the output slots in SoEngine instances. More...

`#include <Inventor/engines/SoEngine.h>`

## Public Member Functions
| SoEngineOutput (void)
virtual | ~SoEngineOutput (void)
SoType | getConnectionType (void) const
int | getForwardConnections (SoFieldList &fl) const
void | enable (const SbBool flag)
SbBool | isEnabled (void) const
SoEngine * | getContainer (void) const
SoNodeEngine * | getNodeContainer (void) const
SbBool | isNodeEngineOutput (void) const
void | setContainer (SoEngine *engine)
void | setNodeContainer (SoNodeEngine *nodeengine)
void | addConnection (SoField *f)
void | removeConnection (SoField *f)
int | getNumConnections (void) const
SoField * | operator[] (int i) const
void | prepareToWrite (void) const
void | doneWriting (void) const
void | touchSlaves (SoNotList *nl, SbBool donotify)
SoFieldContainer * | getFieldContainer (void)

## Detailed Description

The SoEngineOutput class is the output slots in SoEngine instances.

SoEngineOutput has methods for convenient handling of the connections made from SoEngine objects to SoField objects.

See also
  SoEngine, SoField

## Constructor & Destructor Documentation

## ◆ SoEngineOutput()

SoEngineOutput::SoEngineOutput | ( | void |  | ) |

Constructor. The SoEngineOutput will initially not be contained within an SoEngine nor will it have any slave fields attached.

See also
  setContainer()

## ◆ ~SoEngineOutput()

SoEngineOutput::~SoEngineOutput | ( | void |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getConnectionType()

SoType SoEngineOutput::getConnectionType | ( | void |  | ) | const

Returns the type of the engine output.

## ◆ getForwardConnections()

int SoEngineOutput::getForwardConnections | ( | SoFieldList & | fl | ) | const

Adds all slave fields connected to this output to fl. Returns the number of slaves.

See also
  addConnection()
  removeConnection()

## ◆ enable()

void SoEngineOutput::enable | ( | const SbBool | flag | ) |

Sets the enabled flag. If output is disabled, the fields connected to this output will not be changed when the engine is evaluated.

See also
  isEnabled().

## ◆ isEnabled()

SbBool SoEngineOutput::isEnabled | ( | void |  | ) | const

Returns status of the enabled flag.

See also
  enable().

## ◆ getContainer()

SoEngine * SoEngineOutput::getContainer | ( | void |  | ) | const

Returns the engine containing this output. If the engine containing this output is a NodeEngine, this method returns NULL.

See also
  setContainer(), getNodeContainer()

## ◆ getNodeContainer()

SoNodeEngine * SoEngineOutput::getNodeContainer | ( | void |  | ) | const

Returns the node engine containing this output. If the engine containing this output is not a NodeEgine, this method returns NULL.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

See also
  setNodeContainer(), getContainer()

Since
  Coin 2.0

## ◆ isNodeEngineOutput()

SbBool SoEngineOutput::isNodeEngineOutput | ( | void |  | ) | const

Returns TRUE if the container is a NodeEngine.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

See also
  getNodeContainer(), getContainer()

Since
  Coin 2.0

## ◆ setContainer()

void SoEngineOutput::setContainer | ( | SoEngine * | engine | ) |

Sets the engine containing this output.

See also
  getContainer()

## ◆ setNodeContainer()

void SoEngineOutput::setNodeContainer | ( | SoNodeEngine * | nodeengine | ) |

Sets the NodeEngine containing this output.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

See also
  getNodeContainer()

Since
  Coin 2.0

## ◆ addConnection()

void SoEngineOutput::addConnection | ( | SoField * | f | ) |

Adds f to the list of connections from this output.

Adds 1 to the reference count of the container engine.

See also
  removeConnection(), getForwardConnections()

## ◆ removeConnection()

void SoEngineOutput::removeConnection | ( | SoField * | f | ) |

Removes f from the list of connections from this output.

Subtracts 1 from the reference count of the container engine. If the reference count reaches zero (which will happen if this was the last connection and the application programmer did not explicitly ref the engine), the container engine will be deallocated.

See also
  addConnection(), getForwardConnections()

## ◆ getNumConnections()

int SoEngineOutput::getNumConnections | ( | void |  | ) | const

Returns the number of fields in the list of connections.

See also
  operator[], addConnection()

## ◆ operator[]()

SoField * SoEngineOutput::operator[] | ( | int | i | ) | const

Returns the field at index i in the list of connections.

Please note that this might not be the same field as the one the output was originally connected to, since a field converted might have been inserted to converted the output to match the field type.

See also
  getNumConnections()

## ◆ prepareToWrite()

void SoEngineOutput::prepareToWrite | ( | void |  | ) | const

Disables notifications on fields connected to this output. This is done before the engine is evaluated, since the fields we are going to write into have already been notified.

See also
  doneWriting()

## ◆ doneWriting()

void SoEngineOutput::doneWriting | ( | void |  | ) | const

Restores the notification flags on fields connected to this output after evaluating.

See also
  prepareToWrite()

## ◆ touchSlaves()

void SoEngineOutput::touchSlaves | ( | SoNotList * | nl,
|  | SbBool | donotify )

Notify the fields attached to this engine output that the output value has changed.

If donotify is `TRUE`, propagate the notification to the fields. Otherwise just mark the fields "dirty" for re-evaluation.

Note that this method is not part of the original Open Inventor API.

## ◆ getFieldContainer()

SoFieldContainer * SoEngineOutput::getFieldContainer | ( | void |  | ) |

Convenience method that returns a field container. This method can be used both for NodeEngine and Engine outputs.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.0

The documentation for this class was generated from the following files:

- SoEngineOutput.h
- SoEngineOutput.cpp